#========================================================================================
# package      DE_EPAGES::Saferpay2::API::Tools
# state        public
#----------------------------------------------------------------------------------------
# description  Tooling for specific tasks
#========================================================================================
package DE_EPAGES::Saferpay2::API::Tools;

use base qw( Exporter );
use strict;

our @EXPORT_OK = qw (
    HandleTransactionResponse
);


#========================================================================================
# function     HandleTransactionResponse
# state        public
#----------------------------------------------------------------------------------------
# syntax       $hResponse = HandleTransactionResponse($hResponse);
#----------------------------------------------------------------------------------------
# description  Checks if the response contains errors
#----------------------------------------------------------------------------------------
# input        $hResponse | hash
# return       $hResponse | hash
#========================================================================================
sub HandleTransactionResponse {
    my ($hResponse) = @_;

    $hResponse->{'HasErrorsInResponse'} = 0;

    if ( defined($hResponse->{'ErrorName'}) ) {
        $hResponse->{'Transaction'}->{'Id'} = $hResponse->{'TransactionId'} // 'NONE';
        $hResponse->{'Transaction'}->{'Status'} = 'FAILED';
        $hResponse->{'Transaction'}->{'ExternalStatus'} = $hResponse->{'ErrorName'};
        $hResponse->{'HasErrorsInResponse'} = 1;
    } else {
        $hResponse->{'Transaction'}->{'ExternalStatus'} = $hResponse->{'Transaction'}->{'Status'};
    }

    return $hResponse;
}

1;
