#========================================================================================
# package      DE_EPAGES::Saferpay2::t::unit::LineItemPaymentSaferpay2.t
# base         DE_EPAGES::Core::API::Test
# state        public
#----------------------------------------------------------------------------------------
# description  Unit test for DE_EPAGES::Saferpay2::API::LineItemPaymentSaferpay2
#========================================================================================
package DE_EPAGES::Saferpay2::t::unit::LineItemPaymentSaferpay2;
use base DE_EPAGES::Core::API::Test;
use Test::Mockify;
use Test::Mockify::Sut;
use DE_EPAGES::Test::Mock::MockifyEpagesObject;
use Test::Mockify::Verify qw ( GetParametersFromMockifyCall );

use Test::More;

use strict;


sub test {
    my $self = shift;

    $self->test_updateTransactionStatus();
    done_testing();
}


sub test_updateTransactionStatus {
    my $self = shift;
    my $SubTestName = ( caller(0) )[3];

    my $SUT = $self->_createSUT();
    my ($TransID, $TransStatus, $ExternalStatus) = ('1', 'AUTHORIZED', 'AUTHORIZED');
    $SUT->updateTransactionStatus($TransID, $TransStatus, $ExternalStatus);

    my $aUpdateTransactionStatusParameters = GetParametersFromMockifyCall($SUT , 'set');

    my $aExpectedParameters = [{
        'TransStatus'  => $TransStatus,
        'ExternalStatus'  => $ExternalStatus,
        'TransID' => $TransID,
    }];

    ok(defined($aUpdateTransactionStatusParameters->[0]->{'TransTime'}), "$SubTestName - TransTime exists ok.");
    delete $aUpdateTransactionStatusParameters->[0]->{'TransTime'};
    is_deeply($aUpdateTransactionStatusParameters, $aExpectedParameters, "$SubTestName - updateTransactionStatus set parameters ok.");

}

sub _createSUT {
    my $self = shift;

    my $MockifySut = Test::Mockify::Sut->new('DE_EPAGES::Saferpay2::API::Object::LineItemPaymentSaferpay2');
    $MockifySut->mock('set')->whenAny()->thenReturnUndef();
    $MockifySut->mockImported('DE_EPAGES::ExternalPayment::API::Log', 'LogPayment')->whenAny()->thenReturnUndef();
    return $MockifySut->getMockObject();
}


__PACKAGE__->runScript();
